import java.util.Iterator;
import java.util.NoSuchElementException;

public class MyArrayListIterator<T> implements Iterator<T> {
    private T[] array;
    private int size;
    private int nextIndex;
    
    public MyArrayListIterator(T[] array, int size) {
        this.array = array;
        this.size = size;
        this.nextIndex = 0;
    }
    
    @Override
    public boolean hasNext() {
        // array: [a, b, c, d]
        // size:  4
        // nextIndex: 0  -> true
        // nextIndex: 1  -> true
        // nextIndex: 2  -> true
        // nextIndex: 3  -> true
        // nextIndex: 4  -> false
        
        return this.nextIndex < this.size;
    }

    @Override
    public T next() {
        if (!this.hasNext()) {
            throw new NoSuchElementException();
        }
        
        T thingToReturn = this.array[this.nextIndex];
        this.nextIndex += 1;
        return thingToReturn;
    }
}
